ZOJ Seven-Segment Display 暴力dfs + 剪枝

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=3954

0 = on     1 = off

A seven segment code of permutation p is a set of seven segment code derived from the standard code by rearranging the bits into the order indicated by p. For example, the seven segment codes of permutation "gbedcfa" which is derived from the standard code by exchanging the bits represented by "a" and "g", and by exchanging the bits represented by "c" and "e", is listed as follows.

X g b e d c f a
1 1 0 1 1 0 1 1
2 0 0 0 0 1 1 0
3 0 0 1 0 0 1 0
4 0 0 1 1 0 0 1
5 0 1 1 0 0 0 0
6 0 1 0 0 0 0 0
7 1 0 1 1 0 1 0
8 0 0 0 0 0 0 0
9 0 0 1 0 0 0 0

We indicate the seven segment code of permutation p representing number x as cp, x. For example cabcdefg,7 = 0001111, and cgbedcfa,7 = 1011010.

Given n seven segment codes s1, s2, ... , sn and the numbers x1, x2, ... , xn each of them represents, can you find a permutation p, so that for all 1 ≤ in, si = cp, xi holds?

Input

The first line of the input is an integer T (1 ≤ T ≤ 105), indicating the number of test cases. Then T test cases follow.

The first line of each test case contains an integer n (1 ≤ n ≤ 9), indicating the number of seven segment codes.

For the next n lines, the i-th line contains a number xi (1 ≤ xi ≤ 9) and a seven segment code si (|si| = 7), their meanings are described above.

It is guaranteed that ∀ 1 ≤ i < jn, xixj holds for each test case.

Output

For each test case, output "YES" (without the quotes) if the permutation p exists. Otherwise output "NO" (without the quotes).

Sample Input

3
9
1 1001111
2 0010010
3 0000110
4 1001100
5 0100100
6 0100000
7 0001111
8 0000000
9 0000100
2
1 1001111
7 1010011
2
7 0101011
1 1101011

Sample Output

YES
NO
YES

Hint

For the first test case, it is a standard combination of the seven segment codes.

For the second test case, we can easily discover that the permutation p does not exist, as three in seven bits are different between the seven segment codes of 1 and 7.

For the third test case, p = agbfced.


Author: WANG, Yucheng
Source: The 17th Zhejiang University Programming Contest Sponsored by TuSimple

Submit    Status

一点思路都没有,那只能暴力了,

7! * 1e5 = 5e8会T

其实可以一直剪枝,每次dfs的时候,设排列数为now[i]表示放在第i位的字母是now[i],那么,比如1的是"1001111",如果你把第2位放的字母不是b或c,则不处理下去。

biao[i][j]表示数字i的第j位本来应该的状态,0/1

str[i][j]表示数字i的第j位的状态。

那么如果第一位我放的是字母e,本来第一位的状态应该是biao[i][1],现在放了字母e,状态是str[i][e],判断一下是否相等即可。

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <assert.h>
#define IOS ios::sync_with_stdio(false)
using namespace std;
#define inf (0x3f3f3f3f)
typedef long long int LL;


#include <iostream>
#include <sstream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <bitset>
int f[] = {0, 1, 2, 3, 4, 5, 6, 7};
char str[20][44];
int arr[22];
int biao[10][10] = {
{0},
{-1, 1, 0, 0, 1, 1, 1, 1, 5},
{-1, 0, 0, 1, 0, 0, 1, 0, 2},
{-1, 0, 0, 0, 0, 1, 1, 0, 2},
{-1, 1, 0, 0, 1, 1, 0, 0, 3},
{-1, 0, 1, 0, 0, 1, 0, 0, 2},
{-1, 0, 1, 0, 0, 0, 0, 0, 1},
{-1, 0, 0, 0, 1, 1, 1, 1, 4},
{-1, 0, 0, 0, 0, 0, 0, 0, 0},
{-1, 0, 0, 0, 0, 1, 0, 0, 1},
};
bool flag;
bool vis[33];
int n;
int now[33];
void dfs(int cur) {
    if (flag) return;
    if (cur == 7 + 1) {
        printf("YES
");
        flag = true;
        return;
    }
    for (int i = 1; i <= 7; ++i) {
        if (vis[i]) continue;
        now[cur] = i;
        bool flag = true;
        for (int k = 1; k <= n; ++k) {
            if (biao[arr[k]][cur] != str[arr[k]][i] - '0') {
                flag = false;
                break;
            }
        }
        if (flag) {
            vis[i] = true;
            dfs(cur + 1);
            vis[i] = false;
        }
    }
}
void work() {
    scanf("%d", &n);
    for (int i = 1; i <= n; ++i) {
        int id;
        scanf("%d", &id);
        scanf("%s", str[id] + 1);
        arr[i] = id;
    }
    for (int i = 1; i <= n; ++i) {
        int cnt = 0;
        for (int j = 1; j <= 7; ++j) {
            cnt += str[arr[i]][j] == '1';
        }
        if (cnt != biao[arr[i]][8]) {
            printf("NO
");
            return;
        }
    }
    memset(vis, 0, sizeof vis);
    flag = false;
    dfs(1);
    if (flag == false) {
        printf("NO
");
    }
}

int main() {
#ifdef local
    freopen("data.txt", "r", stdin);
//    freopen("data.txt", "w", stdout);
#endif
    int t;
    scanf("%d", &t);
    while (t--) {
        work();
    }
    return 0;
}
View Code
原文地址:https://www.cnblogs.com/liuweimingcprogram/p/6691600.html